VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsEquation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Dirty As Boolean
Private Parsed As Boolean

Private Vars As New Collection
Private Equ As String
Private Deg As Boolean

Private dAnswer As Double
Private EquParsed As Collection
Private EquOrder  As Collection

Private Const PRI_ADD = 1
Private Const PRI_MOD = 2
Private Const PRI_MUL = 3
Private Const PRI_NEG = 4
Private Const PRI_EXP = 5
Private Const PRI_VAR = 6
Private Const PRI_PAR = 7
Private Const PRI_LEVEL = 7

Private Const EQ_NONE = 0
Private Const EQ_STRING = 1
Private Const EQ_NUMBER = 2

Private Const ER_NONE = 0
Private Const ER_VAR = 1

Private Const EQ_PAREN = 1100
Private Const EQ_FUNCTION = 1101
Private Const EQ_VARIABLE = 1102
Private Const EQ_INVALID = 1103
Private Const EQ_ARGS = 1104
Private Const EQ_NAME = 1105

Private Const PI = 3.14159265358979
Private Const DEG_TO_RAD = 0.01745329251995
Private Const RAD_TO_DEG = 57.2957795131
Public Property Let Degrees(b As Boolean)
    If b <> Deg Then
        Deg = b
        Dirty = True
    End If
End Property

Public Property Get Degrees() As Boolean
    Degrees = Deg
End Property

Private Function GetRight(ByVal j As Long, v() As Variant) As Long
    Dim I As Long
    For I = j + 1 To UBound(v)
        If Not IsNull(v(I)) Then
            GetRight = I
            Exit Function
        End If
    Next I
    GetRight = 0
End Function

Private Function GetLeft(ByVal j As Long, v() As Variant) As Long
    Dim I As Long
    For I = j - 1 To 1 Step -1
        If Not IsNull(v(I)) Then
            GetLeft = I
            Exit Function
        End If
    Next I
    GetLeft = 0
End Function

Public Sub VarClear()
    Set Vars = New Collection
    Dirty = True
End Sub

Public Property Let Equation(e As String)
    Parsed = False
    Dirty = True
    Equ = LCase(e)
End Property

Public Property Get Equation() As String
    Equation = Equ
End Property

Private Sub Parse()
    Dim I As Integer
    Dim S As String
    Dim t As Integer
    Dim j As Integer
    Dim sTmp As String
    Dim p As Integer
    Dim EquPriority As New Collection
    Dim maxPriority
    Dim isNeg As Boolean
    S = ""
    t = EQ_NONE
    j = 1
    p = 0
    isNeg = False
    Set EquParsed = New Collection
    EquParsed.Add ""
    EquPriority.Add ""
    maxPriority = PRI_LEVEL
    For I = 1 To Len(Equ)
        sTmp = Mid$(Equ, I, 1)
        Select Case sTmp
            Case "A" To "Z", "a" To "z", "_"
            If t = EQ_NONE Then
                t = EQ_STRING
                S = sTmp
            ElseIf t = EQ_NUMBER Then
                t = EQ_STRING
                EquParsed.Add S, , j
                EquPriority.Add 0, , j
                j = j + 1
                EquParsed.Add "*", , j
                EquPriority.Add PRI_MUL + p, , j
                j = j + 1
                S = sTmp
            Else
                S = S + sTmp
            End If
            isNeg = True
      Case "1" To "9", "0", "."
            If t = EQ_NONE Then
                t = EQ_NUMBER
                S = sTmp
            Else
                S = S + sTmp
            End If
            isNeg = True
      Case "(":
            If t = EQ_STRING Then
                EquParsed.Add S + sTmp, , j
                EquPriority.Add p + PRI_PAR, , j
                j = j + 1
                S = ""
            ElseIf t = EQ_NUMBER Then
                EquParsed.Add S, , j
                EquPriority.Add 0, , j
                j = j + 1
                EquParsed.Add "*", , j
                EquPriority.Add p + PRI_MUL, , j
                j = j + 1
                EquParsed.Add sTmp, , j
                EquPriority.Add p + PRI_PAR, , j
                j = j + 1
                S = ""
            Else
                EquParsed.Add sTmp, , j
                EquPriority.Add p + PRI_PAR, , j
                j = j + 1
            End If
            p = p + PRI_LEVEL
            t = EQ_NONE
            If maxPriority < p + PRI_LEVEL Then
                maxPriority = p + PRI_LEVEL
            End If
            isNeg = False
        Case "*", "/":
            If t <> EQ_NONE Then
                EquParsed.Add S, , j
                EquPriority.Add IIf(t = EQ_STRING, p + PRI_VAR, 0), , j
                j = j + 1
                S = ""
            End If
            EquParsed.Add sTmp, , j
            EquPriority.Add p + PRI_MUL, , j
            j = j + 1
            t = EQ_NONE
            isNeg = False
        Case "\":
            If t <> EQ_NONE Then
                EquParsed.Add S, , j
                EquPriority.Add IIf(t = EQ_STRING, p + PRI_VAR, 0), , j
                j = j + 1
                S = ""
            End If
            EquParsed.Add sTmp, , j
            EquPriority.Add p + PRI_MUL, , j
            j = j + 1
            t = EQ_NONE
            isNeg = False
        Case "+":
            If t <> EQ_NONE Then
                EquParsed.Add S, , j
                EquPriority.Add IIf(t = EQ_STRING, p + PRI_VAR, 0), , j
                j = j + 1
                S = ""
                EquParsed.Add sTmp, , j
                EquPriority.Add p + PRI_ADD, , j
                j = j + 1
                t = EQ_NONE
            Else
            End If
            isNeg = False
        Case "-":
            If t <> EQ_NONE Then
                EquParsed.Add S, , j
                EquPriority.Add IIf(t = EQ_STRING, p + PRI_VAR, 0), , j
                j = j + 1
                S = ""
            End If
            If isNeg Then
                EquParsed.Add sTmp, , j
                EquPriority.Add p + PRI_ADD, , j
                j = j + 1
                t = EQ_NONE
            Else
                EquParsed.Add "~", , j
                EquPriority.Add p + PRI_NEG, , j
                j = j + 1
                t = EQ_NONE
            End If
            isNeg = False
        Case "^":
            If t <> EQ_NONE Then
                EquParsed.Add S, , j
                EquPriority.Add IIf(t = EQ_STRING, p + PRI_VAR, 0), , j
                j = j + 1
                S = ""
            End If
            EquParsed.Add sTmp, , j
            EquPriority.Add p + PRI_EXP, , j
            j = j + 1
            t = EQ_NONE
            isNeg = False
        Case "%":
            If t <> EQ_NONE Then
                EquParsed.Add S, , j
                EquPriority.Add IIf(t = EQ_STRING, p + PRI_VAR, 0), , j
                j = j + 1
                S = ""
            End If
            EquParsed.Add sTmp, , j
            EquPriority.Add p + PRI_MOD, , j
            j = j + 1
            t = EQ_NONE
            isNeg = False
        Case ",":
            If t <> EQ_NONE Then
                EquParsed.Add S, , j
                EquPriority.Add IIf(t = EQ_STRING, p + PRI_VAR, 0), , j
                j = j + 1
                S = ""
            End If
            EquParsed.Add Null, , j
            EquPriority.Add 0, , j
            j = j + 1
            t = EQ_NONE
            isNeg = False
        Case ")":
            If t <> EQ_NONE Then
                EquParsed.Add S, , j
                EquPriority.Add IIf(t = EQ_STRING, p + PRI_VAR, 0), , j
                j = j + 1
                S = ""
            End If
            EquParsed.Add sTmp, , j
            EquPriority.Add p - (PRI_LEVEL - PRI_PAR), , j
            p = p - PRI_LEVEL
            j = j + 1
            t = EQ_NONE
            isNeg = True
        End Select
    Next I
    If S <> "" Then
        EquParsed.Add S, , j
        EquPriority.Add IIf(t = EQ_STRING, p + PRI_VAR, 0), , j
        j = j + 1
    End If
    EquParsed.Remove j
    EquPriority.Remove j
    If p <> 0 Then
        Err.Raise EQ_PAREN, "clsEquation", "Unbalanced parenthesis"
        Exit Sub
    End If
    Set EquOrder = New Collection
    EquOrder.Add ""
    For j = 1 To maxPriority
        For I = EquPriority.Count To 1 Step -1
            If EquPriority(I) = j Then
                EquOrder.Add I, , , 1
            End If
        Next I
    Next j
    EquOrder.Remove 1
    Parsed = True
End Sub

Public Sub VarRemove(Name As String)
    On Error Resume Next
    Vars.Remove Name
    Dirty = True
End Sub

Public Function Solution() As Double
    If Dirty Then
        Solve
    End If
    Solution = dAnswer
End Function

Public Sub Solve()
    Dim I As Long
    Dim j As Long
    Dim l As Long
    Dim r As Long
    Dim m As Long
    Dim n As Long
    Dim X As Double
    Dim Y As Double
    Dim v As Variant
    Dim eSpace As Integer
    Dim Temp() As Variant
    Dim f As clsEquation
    Dim j2 As Long
    On Error GoTo SolveError
    If Not Parsed Then
        Parse
    End If
    ReDim Temp(1 To EquParsed.Count)
    For I = 1 To EquParsed.Count
        Temp(I) = EquParsed(I)
    Next
    eSpace = ER_NONE
    For I = 1 To EquOrder.Count
        m = EquOrder(I)
        v = Temp(m)
        Select Case v
            Case "~"
                r = GetRight(m, Temp)
                Temp(m) = -CDbl(Temp(r))
                Temp(r) = Null
            Case "*"
                l = GetLeft(m, Temp)
                r = GetRight(m, Temp)
                Temp(l) = CDbl(Temp(l)) * CDbl(Temp(r))
                Temp(r) = Null
                Temp(m) = Null
            Case "/"
                l = GetLeft(m, Temp)
                r = GetRight(m, Temp)
                Temp(l) = CDbl(Temp(l)) / CDbl(Temp(r))
                Temp(r) = Null
                Temp(m) = Null
            Case "\"
                l = GetLeft(m, Temp)
                r = GetRight(m, Temp)
                Temp(l) = CDbl(Temp(l)) \ CDbl(Temp(r))
                Temp(r) = Null
                Temp(m) = Null
            Case "+"
                l = GetLeft(m, Temp)
                r = GetRight(m, Temp)
                Temp(l) = CDbl(Temp(l)) + CDbl(Temp(r))
                Temp(r) = Null
                Temp(m) = Null
            Case "-"
                l = GetLeft(m, Temp)
                r = GetRight(m, Temp)
                Temp(l) = CDbl(Temp(l)) - CDbl(Temp(r))
                Temp(r) = Null
                Temp(m) = Null
            Case "^"
                l = GetLeft(m, Temp)
                r = GetRight(m, Temp)
                Temp(l) = CDbl(Temp(l)) ^ CDbl(Temp(r))
                Temp(r) = Null
                Temp(m) = Null
            Case "%"
                l = GetLeft(m, Temp)
                r = GetRight(m, Temp)
                Temp(l) = CDbl(Temp(l)) Mod CDbl(Temp(r))
                Temp(r) = Null
                Temp(m) = Null
            Case "("
                I = I + 1
                n = EquOrder(I)
                r = GetRight(m, Temp)
                If r >= n Then
                    Temp(m) = 0#
                    Temp(n) = Null
                Else
                    Temp(m) = Temp(r)
                    Temp(r) = Null
                    Temp(n) = Null
                End If
            Case Else
                If right$(Temp(m), 1) = "(" Then
                    I = I + 1
                    n = EquOrder(I)
                    l = GetRight(m, Temp)
                    r = GetLeft(n, Temp)
                    If l >= n Then
                        Err.Raise EQ_ARGS, "clsEquation", "Invalid arguments to function: " & v & ")"
                        Exit Sub
                    Else
                        X = CDbl(Temp(l))
                    End If
                    If r <= m Then
                        Err.Raise EQ_ARGS, "clsEquation", "Invalid arguments to function: " & v & ")"
                        Exit Sub
                    Else
                        Y = CDbl(Temp(r))
                    End If
                    Temp(r) = Null
                    Temp(l) = Null
                    Temp(m) = Null
                    Temp(n) = Null
                    Select Case v
                        Case "abs("
                            Temp(m) = Abs(X)
                        Case "atn("
                            If Degrees Then
                                Temp(m) = Atn(X) * RAD_TO_DEG
                            Else
                                Temp(m) = Atn(X)
                            End If
                        Case "arctan("
                            If Degrees Then
                                Temp(m) = Atn(X) * RAD_TO_DEG
                            Else
                                Temp(m) = Atn(X)
                            End If
                        Case "cos("
                            If Degrees Then
                                Temp(m) = Cos(X * DEG_TO_RAD)
                            Else
                                Temp(m) = Cos(X)
                            End If
                        Case "exp("
                            Temp(m) = Exp(X)
                        Case "fix("
                            Temp(m) = Fix(X)
                        Case "int("
                            Temp(m) = Int(X)
                        Case "log("
                            Temp(m) = Log(X)
                        Case "rnd("
                            Temp(m) = Rnd(X)
                        Case "sgn("
                            Temp(m) = Sgn(X)
                        Case "sin("
                            If Degrees Then
                                Temp(m) = Sin(X * DEG_TO_RAD)
                            Else
                                Temp(m) = Sin(X)
                            End If
                        Case "sqr("
                            Temp(m) = Sqr(X)
                        Case "tan("
                            If Degrees Then
                                Temp(m) = Tan(X * DEG_TO_RAD)
                            Else
                                Temp(m) = Tan(X)
                            End If
                        Case "min("
                            Temp(m) = IIf(X < Y, X, Y)
                        Case "max("
                            Temp(m) = IIf(X > Y, X, Y)
                        Case "random("
                            Temp(m) = (Rnd * (Y - X)) + X
                        Case "mod("
                            Temp(m) = X Mod Y
                        Case "logn("
                            Temp(m) = Log(X) / Log(Y)
                        Case "rand("
                            Temp(m) = Int(Rnd * X)
                        Case "sec("
                            If Degrees Then
                                Temp(m) = (1 / Cos(X * DEG_TO_RAD))
                            Else
                                Temp(m) = 1 / Cos(X)
                            End If
                        Case "cosec("
                            If Degrees Then
                                Temp(m) = (1 / Sin(X * DEG_TO_RAD))
                            Else
                                Temp(m) = 1 / Sin(X)
                            End If
                        Case "cotan("
                            If Degrees Then
                                Temp(m) = (1 / Tan(X * DEG_TO_RAD))
                            Else
                                Temp(m) = 1 / Tan(X)
                            End If
                        Case "arcsin("
                            If Degrees Then
                                Temp(m) = (Atn(X / Sqr(-X * X + 1))) * RAD_TO_DEG
                            Else
                                Temp(m) = Atn(X / Sqr(-X * X + 1))
                            End If
                        Case "arccos("
                            If Degrees Then
                                Temp(m) = (Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)) * RAD_TO_DEG
                            Else
                                Temp(m) = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)
                            End If
                        Case "arcsec("
                            If Degrees Then
                                Temp(m) = (Atn(X / Sqr(X * X - 1)) + (Sgn(X) - 1) * (2 * Atn(1))) * RAD_TO_DEG
                            Else
                                Temp(m) = Atn(X / Sqr(X * X - 1)) + (Sgn(X) - 1) * (2 * Atn(1))
                            End If
                        Case "arccosec("
                            If Degrees Then
                                Temp(m) = (Atn(X / Sqr(X * X - 1)) + (Sgn(X) - 1) * (2 * Atn(1))) * RAD_TO_DEG
                            Else
                                Temp(m) = Atn(X / Sqr(X * X - 1)) + (Sgn(X) - 1) * (2 * Atn(1))
                            End If
                        Case "arccotan("
                            If Degrees Then
                                Temp(m) = (Atn(X * DEG_TO_RAD) + 2 * Atn(1)) * RAD_TO_DEG
                            Else
                                Temp(m) = Atn(X) + 2 * Atn(1)
                            End If
                        Case "sinh("
                            Temp(m) = (Exp(X) - Exp(-X)) / 2
                        Case "cosh("
                            Temp(m) = (Exp(X) - Exp(-X)) / (Exp(X) + Exp(-X))
                        Case "tanh("
                            Temp(m) = (Exp(X) - Exp(-X)) / (Exp(X) + Exp(-X))
                        Case "sech("
                            Temp(m) = 2 / (Exp(X) + Exp(-X))
                        Case "cosech("
                            Temp(m) = 2 / (Exp(X) - Exp(-X))
                        Case "cotanh("
                            Temp(m) = (Exp(X) + Exp(-X)) / (Exp(X) - Exp(-X))
                        Case "arcsinh("
                            Temp(m) = Log(X + Sqr(X * X + 1))
                        Case "arccosh("
                            Temp(m) = Log(X + Sqr(X * X - 1))
                        Case "arctanh("
                            Temp(m) = Log((1 + X) / (1 - X)) / 2
                        Case "arcsech("
                            Temp(m) = Log((Sqr(-X * X + 1) + 1) / X)
                        Case "arccosech("
                            Temp(m) = Log((Sgn(X) * Sqr(X * X + 1) + 1) / X)
                        Case "arccotanh("
                            Temp(m) = Log((X + 1) / (X - 1)) / 2
                        Case "log10("
                            Temp(m) = Log(X) / Log(10)
                        Case "log2("
                            Temp(m) = Log(X) / Log(2)
                        Case "ln("
                            Temp(m) = Log(X)
                        Case "deg("
                            Temp(m) = X * RAD_TO_DEG
                        Case "rad("
                            Temp(m) = X * DEG_TO_RAD
                        Case Else
                            Err.Raise EQ_FUNCTION, "clsEquation", "Undefined Function: " & v & ")"
                            Exit Sub
                    End Select
                Else
                    Select Case v
                        Case "pi":
                            Temp(m) = PI
                        Case "e":
                            Temp(m) = 2.718281828
                        Case "rnd":
                            Temp(m) = Rnd
                        Case Else
                            eSpace = ER_VAR
                            Temp(m) = CDbl(Vars(Temp(m)))
                            eSpace = ER_NONE
                    End Select
                End If
        End Select
    Next I
   
    dAnswer = CDbl(Temp(GetRight(0, Temp)))
    Dirty = False
    Exit Sub
SolveError:
    Select Case Err
        Case 6, 11, EQ_PAREN To EQ_NAME
            Err.Raise Err, "clsEquation", Err.Description
        Case 5:
            Select Case eSpace
                Case ER_VAR
                    Err.Raise EQ_VARIABLE, "clsEquation", "Undefined Variable: " & v
                Case Else
                    Err.Raise Err, "clsEquation", Err.Description
            End Select
        Case Else
            Err.Raise EQ_INVALID, "clsEquation", "Invalid Equation"
    End Select
End Sub

Public Property Get Var(Name As String) As Double
    On Error GoTo GetError
    Var = CDbl(Vars(Name))
    Exit Property
GetError:
    Var = 0#
End Property

Public Property Let Var(Name As String, Num As Double)
    On Error Resume Next
    Dirty = True
    Vars.Remove Name
    Vars.Add Num, Name
End Property

Private Sub Class_Initialize()
    Dirty = False
    Parsed = True
    Degrees = False
End Sub
